﻿using Syncfusion.Data;
using Syncfusion.SfDataGrid.XForms;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace XamarinForms
{
    public class App : Application
    {
        SfDataGrid dataGrid;
        ViewModel viewModel;
        public App()
        {
            dataGrid = new SfDataGrid();
            viewModel = new ViewModel();
            dataGrid.AutoGenerateColumns = true;
            dataGrid.AllowSorting = true;
            dataGrid.ColumnSizer = ColumnSizer.Auto;
            dataGrid.AutoGenerateColumns = false;
            dataGrid.ItemsSource = viewModel.OrdersInfo;
            dataGrid.GroupColumnDescriptions.Add(new GroupColumnDescription() { ColumnName = "GroupProperty" });
            MainPage = new ContentPage() { Content = dataGrid };
            dataGrid.Columns.Add(new GridTextColumn() { MappingName = "OrderID" });
            dataGrid.Columns.Add(new GridTextColumn() { MappingName = "CustomerID" });
            dataGrid.Columns.Add(new GridTextColumn() { MappingName = "EmployeeID" });
            dataGrid.Columns.Add(new GridTextColumn() { MappingName = "FirstName" });
            dataGrid.Columns.Add(new GridTextColumn() { MappingName = "LastName" });
            dataGrid.AutoGeneratingColumn += DataGrid_AutoGeneratingColumn;
            dataGrid.QueryRowHeight += DataGrid_QueryRowHeight;
        }

        private void DataGrid_AutoGeneratingColumn(object sender, AutoGeneratingColumnEventArgs e)
        {
            if (e.Column.MappingName == "GroupProperty")
                e.Cancel = true;
        }

        private void DataGrid_QueryRowHeight(object sender, QueryRowHeightEventArgs e)
        {
            if(dataGrid.IsCaptionSummaryRow(e.RowIndex))
            {
              var captionRow = dataGrid.GetRowGenerator().Items.FirstOrDefault(rw => rw.RowIndex == e.RowIndex);
                if(captionRow != null)
                {
                    var group = captionRow.RowData as Group;
                    if (group != null && group.Key.ToString() == "zzexcludedGroup")
                    {
                        e.Height = 0;
                        e.Handled = true;
                    }
                }
            }
        }

        protected override void OnStart()
        {
            // Handle when your app starts
        }

        protected override void OnSleep()
        {
            // Handle when your app sleeps
        }

        protected override void OnResume()
        {
            // Handle when your app resumes
        }
    }
}
